import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

import java.util.*;

/**
 * Write a description of class Worldy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worldy extends World {
    int x = 0;
    int y = 0;
    
    Building[][] city;
    
    double zoom = 3;
    int bSize = (int)(20*zoom);
    int rSize = (int)(13*zoom);
    
    boolean showLines = false;
    Color outline = Color.BLACK;
    
    public Worldy() {
        super(600, 600, 1);
        city = new Building[500][500];
        for(int x = 0; x < city.length; x++) {
            for(int y = 0; y < city[0].length; y++) {
                Color c = null;
                switch(Greenfoot.getRandomNumber(7)) {
                    case 0: c = Color.WHITE;
                        break;
                    case 1: c = Color.GRAY;
                        break;
                    case 2: c = Color.RED;
                        break;
                    case 3: c = Color.ORANGE;
                        break;
                    case 4: c = Color.YELLOW;
                        break;
                    case 5: c = Color.GREEN;
                        break;
                    case 6: c = Color.BLUE;
                        break;
                }
                city[x][y] = new Building(c, Greenfoot.getRandomNumber(70)+20, x, y, Greenfoot.getRandomNumber(2)==0);
            }
        }
        render();
    }
    
    public void act() {
        int speed = 2;
        if(Greenfoot.isKeyDown("a")) {
            x -= speed;
            render();
        } else if(Greenfoot.isKeyDown("d")) {
            x += speed;
            render();
        }
        if(Greenfoot.isKeyDown("w")) {
            y -= speed;
            render();
        } else if(Greenfoot.isKeyDown("s")) {
            y += speed;
            render();
        }
        if("e".equals(Greenfoot.getKey())) {
            showLines = !showLines;
            render();
        }
    }
    
    public void render() {
        getBackground().setColor(Color.BLACK);
        getBackground().fill();
        Building[] range = getRange();
        List<Building> sortedRange = new ArrayList();
        for(Building a:range) {
            int aRX = getBuildingX(a.x)-this.x;
            int aRY = getBuildingY(a.y)-this.y;
            double aDistance = aRX*aRX+aRY*aRY;
            if(sortedRange.size() == 0) sortedRange.add(a);
            else {
                for(Building b:sortedRange) {
                    int bRX = getBuildingX(b.x)-this.x;
                    int bRY = getBuildingY(b.y)-this.y;
                    double bDistance = bRX*bRX+bRY*bRY;
                    if(bDistance <= aDistance) {
                        sortedRange.add(sortedRange.indexOf(b), a);
                        break;
                    } else if(sortedRange.indexOf(b)+1 == sortedRange.size()) {
                        sortedRange.add(a);
                        break;
                    }
                }
            }
        }
        for(Building i:sortedRange) {
            int scale = 10;
            int rrX = getBuildingX(i.x)-this.x;
            int rrY = getBuildingY(i.y)-this.y;
            double mag = Math.sqrt(rrX*rrX+rrY*rrY);
            double height = i.height/scale;
            int rX = (int)(getWidth()/2+rrX-bSize/2);
            int rY = (int)(getHeight()/2+rrY-bSize/2);
            double pHeight = (i.height+10)/scale;
            int ttX = (int)(getWidth()/2+rrX*pHeight);
            int ttY = (int)(getHeight()/2+rrY*pHeight);
            int tX = (int)(getWidth()/2+(rrX-bSize/2)*height);
            int tY = (int)(getHeight()/2+(rrY-bSize/2)*height);
            int tSize = (int)(bSize*height);
            Color color = i.color;
            Color shade = color.darker();
            Color shade2 = shade.darker();
            if(rrX+bSize/2 < 0) {
                getBackground().setColor(color);
                getBackground().fillPolygon(new int[] {rX+bSize, rX+bSize, tX+tSize, tX+tSize}, new int[] {rY, rY+bSize, tY+tSize, tY}, 4);
                if(showLines) {
                    getBackground().setColor(outline);
                    getBackground().drawPolygon(new int[] {rX+bSize, rX+bSize, tX+tSize, tX+tSize}, new int[] {rY, rY+bSize, tY+tSize, tY}, 4);
                }
            } else if(rrX-bSize/2 > 0) {
                getBackground().setColor(shade2);
                getBackground().fillPolygon(new int[] {rX, rX, tX, tX}, new int[] {rY, rY+bSize, tY+tSize, tY}, 4);
                if(showLines) {
                    getBackground().setColor(outline);
                    getBackground().drawPolygon(new int[] {rX, rX, tX, tX}, new int[] {rY, rY+bSize, tY+tSize, tY}, 4);
                }
            }
            if(rrY+bSize/2 < 0) {
                getBackground().setColor(shade2);
                getBackground().fillPolygon(new int[] {rX, rX+bSize, tX+tSize, tX}, new int[] {rY+bSize, rY+bSize, tY+tSize, tY+tSize}, 4);
                if(showLines) {
                    getBackground().setColor(outline);
                    getBackground().drawPolygon(new int[] {rX, rX+bSize, tX+tSize, tX}, new int[] {rY+bSize, rY+bSize, tY+tSize, tY+tSize}, 4);
                }
            } else if(rrY-bSize/2 > 0) {
                getBackground().setColor(color);
                getBackground().fillPolygon(new int[] {rX, rX+bSize, tX+tSize, tX}, new int[] {rY, rY, tY, tY}, 4);
                if(showLines) {
                    getBackground().setColor(outline);
                    getBackground().drawPolygon(new int[] {rX, rX+bSize, tX+tSize, tX}, new int[] {rY, rY, tY, tY}, 4);
                }
            }
            if(i.point) {
                getBackground().setColor(color);
                if(ttX > tX) {
                    getBackground().setColor(shade);
                    getBackground().fillPolygon(new int[] {tX, tX, ttX}, new int[] {tY, tY+tSize, ttY}, 3);
                    if(showLines) {
                        getBackground().setColor(outline);
                        getBackground().drawPolygon(new int[] {tX, tX, ttX}, new int[] {tY, tY+tSize, ttY}, 3);
                    }
                }
                if(ttX < tX+tSize) {
                    getBackground().setColor(color);
                    getBackground().fillPolygon(new int[] {tX+tSize, tX+tSize, ttX}, new int[] {tY, tY+tSize, ttY}, 3);
                    if(showLines) {
                        getBackground().setColor(outline);
                        getBackground().drawPolygon(new int[] {tX+tSize, tX+tSize, ttX}, new int[] {tY, tY+tSize, ttY}, 3);
                    }
                }
                if(ttY > tY) {
                    getBackground().setColor(color);
                    getBackground().fillPolygon(new int[] {tX, tX+tSize, ttX}, new int[] {tY, tY, ttY}, 3);
                    if(showLines) {
                        getBackground().setColor(outline);
                        getBackground().drawPolygon(new int[] {tX, tX+tSize, ttX}, new int[] {tY, tY, ttY}, 3);
                    }
                }
                if(ttY < tY+tSize) {
                    getBackground().setColor(shade);
                    getBackground().fillPolygon(new int[] {tX, tX+tSize, ttX}, new int[] {tY+tSize, tY+tSize, ttY}, 3);
                    if(showLines) {
                        getBackground().setColor(outline);
                        getBackground().drawPolygon(new int[] {tX, tX+tSize, ttX}, new int[] {tY+tSize, tY+tSize, ttY}, 3);
                    }
                }
            } else {
                getBackground().setColor(color);
                getBackground().fillRect(tX, tY, tSize, tSize);
                if(showLines) {
                    getBackground().setColor(outline);
                    getBackground().drawRect(tX, tY, tSize, tSize);
                }
            }
        }
    }
    
    public int getBuildingX(int x) {
        int w = city.length;
        return x*bSize+(x-1)*rSize-(w*bSize+(w-1)*rSize)/2;
    }
    
    public int getBuildingY(int y) {
        int h = city[0].length;
        return y*bSize+(y-1)*rSize-(h*bSize+(h-1)*rSize)/2;
    }
    
    public Building[] getRange() {
        List<Building> lRange = new ArrayList();
        for(int x = 0; x < city.length; x++) {
            if(getBuildingX(x)+bSize+rSize > this.x-getWidth()/2 && getBuildingX(x)-bSize-rSize < this.x+getWidth()/2) {
                for(int y = 0; y < city[0].length; y++) {
                    if(getBuildingY(y)+bSize+rSize > this.y-getHeight()/2 && getBuildingY(y)-bSize-rSize < this.y+getHeight()/2) {
                        lRange.add(city[x][y]);
                    }
                }
            }
        }
        Building[] range = new Building[lRange.size()];
        for(int i = 0; i < lRange.size(); i++) range[i] = lRange.get(i);
        return range;
    }
}
